/*!-------------------------------------------------------------------------------------------------
 - #%L                                                                                            -
 - chvote-pact                                                                                    -
 - %%                                                                                             -
 - Copyright (C) 2016 - 2018 République et Canton de Genève                                       -
 - %%                                                                                             -
 - This program is free software: you can redistribute it and/or modify                           -
 - it under the terms of the GNU Affero General Public License as published by                    -
 - the Free Software Foundation, either version 3 of the License, or                              -
 - (at your option) any later version.                                                            -
 -                                                                                                -
 - This program is distributed in the hope that it will be useful,                                -
 - but WITHOUT ANY WARRANTY; without even the implied warranty of                                 -
 - MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                                   -
 - GNU General Public License for more details.                                                   -
 -                                                                                                -
 - You should have received a copy of the GNU Affero General Public License                       -
 - along with this program. If not, see <http://www.gnu.org/licenses/>.                           -
 - #L%                                                                                            -
 -------------------------------------------------------------------------------------------------*/
/* You can add global styles to this file, and also import other style files */
@import '~@angular/material/theming';
@import '~@chvote/chvote-common-theme/styles/chvote';
@import '~@chvote/chvote-common-theme/styles/theme';
@import 'pact-global';

@include mat-core;

app-root {
  display: flex;
  flex-flow: column;
  height: 100vh;
}

@mixin pact-action-detail($theme) {
  .action-detail {
    @include sidenav-content-component;

    .action-column {
      display: flex;
      flex-direction: column;
      flex-wrap: nowrap;
      width: 100%;
    }

    .action-row {
      display: flex;
      flex-direction: row;
      flex-wrap: nowrap;

      &.action-detail-accordion-detail-row,
      .action-detail-accordion-detail-row .action-detail-main-row {
        padding: 0 0 1.5rem 0;
      }

      &.action-detail-main-row {
        padding: 1.5rem 3rem 1.5rem 3rem;
      }

      &.action-detail-title-row {
        padding-bottom: 1.5rem;
      }

      &.pact-empty-table-msg {
        justify-content: center;
      }

      &.action-button-row {
        justify-content: flex-end;

        .mat-raised-button {
          margin-left: 1rem;
        }
      }
    }

    h2 {
      color: #666;
      font-size: 2rem;
      font-style: normal;
      font-weight: 400;
      line-height: 1.9rem;
    }

    .action-cell, .accordion-title-cell {
      display: flex;
      flex-direction: column;
      flex-wrap: nowrap;
    }

    .action-cell {
      flex-basis: 33%;
    }

    .action-accordion {
      width: 100%;
    }
  }
}

@mixin pact-empty-table-msg($theme) {
  .pact-empty-table-msg {
    text-align: center;
    border-bottom: 1px solid rgba(0, 0, 0, .12);
    padding: 2.0rem;
    color: #666;

    &.no-border {
      border: 0;
    }
  }
}

@mixin pact-mat-dialog($theme) {
  .mat-dialog-content {
    font-size: 1.4em;
    padding-bottom: 1em;
  }

  .mat-dialog-actions {
    justify-content: flex-end;
  }
}

@mixin pact-mat-expansion-panel($theme) {
  .mat-expansion-panel-header-description,
  .mat-expansion-panel-header-title {
    flex-basis: 33%;
    word-break: break-all;
    margin: 0;
    flex-grow: 0;
  }

  .mat-expansion-panel-body {
    padding: 0 32px 16px 24px;
  }
}

@mixin pact-mat-card($theme) {
  $primary: map-get($theme, primary);

  .mat-card {
    padding: 0;

    .mat-tab-group {
      background-color: mat-color($primary, lighter);
    }

    .mat-tab-label-content {
      font-weight: bold;
    }
  }

  .mat-header-cell, .mat-cell {
    font-size: 1.3rem;
    overflow-wrap: break-word;
    margin-right: .6rem;
    margin-left: .6rem;
  }

  .mat-card-header {
    padding: 2.5rem 1.5rem 1.5rem 1.5rem;
  }
}

@mixin global-theme($theme) {
  $primary: map-get($theme, primary);

  margin: 0;
  font-family: Roboto, "Helvetica Neue", sans-serif;

  .readonly-label {
    font-size: 1.4rem;
    color: rgba(black, .5);
    margin-bottom: .3rem;
  }

  .readonly-value {
    font-size: 1.4rem;
    padding-right: 2rem;
    word-break: break-all;
    color: rgba(black, .75);
  }

  .fake {
    text-decoration: line-through;
  }

  .mat-drawer-container {
    background-color: #E0E0E0;
  }
}

.pact-theme {
  @include chvote-theme($chvote-theme);
  @include angular-material-theme($chvote-theme);
  @include global-theme($chvote-theme);
  @include pact-mat-card($chvote-theme);
  @include pact-mat-dialog($chvote-theme);
  @include pact-mat-expansion-panel($chvote-theme);
  @include pact-action-detail($chvote-theme);
  @include pact-empty-table-msg($chvote-theme);
}

html {
  font-size: 62.5%;
}
